/* command line parameter fetching routine */
/* debug stuff too */
#include <stdio.h>
#include "squawk.h"
struct lsp {
    char  imgfile[64];
    char  outfile[64];
    int   hflip;
    int   vflip;
} lpars;
int debug;    /* any routine in the package needs access to this. */

struct lsp *get_params(argc, argv)
int argc;
char *argv[];
{

     char message[80];
     double ceil();

     par_f(lpars.imgfile,"IMAGE,,File containing image");
     par_f(lpars.outfile,"RESULT,,File to contain flipped result");
     par_i(&lpars.hflip,"H_FLIP,0,1,0,Flip horizontally");
     par_i(&lpars.vflip,"V_FLIP,0,1,0,Flip vertically");
     par_i(&debug,"VERBOSITY,1,99,0,Debugging level, check the documentation.");

     if (par_g(argc, argv))
              squawk(Terminal,"Didn't get the input parameters.");

     /* Debug stuff */

     if(debug > 1){

     fprintf(stderr,"Debug level set to %d\n", debug);
     fprintf(stderr,"\nInput parameters are:\n");
     fprintf(stderr,"IMAGE=%s\n",lpars.imgfile);
     fprintf(stderr,"RESULT=%s\n",lpars.outfile);
     fprintf(stderr,"H_FLIP=%s\n",(lpars.hflip)?"True":"False");
     fprintf(stderr,"V_FLIP=%s\n",(lpars.vflip)?"True":"False");
     fprintf(stderr,"DEBUG=%d\n",debug);
     }

     /* Done with getting and checking the inputs, we should be self
      * sufficient now. 
      * return a pointer to the parameter structure
      */

     return( &lpars);
}

main(argc,argv)
int argc;
char *argv[];
{

    struct lsp *sp;

    sp = get_params(argc, argv);

    conductor(sp->imgfile, sp->outfile, sp->hflip, sp->vflip);

    exit(0);
}
