                      DEFAULTS FOR FILES

When the "skyview" program is invoked, default directories are set up as
follows:

	   file type					default directory
	   ----------					-----------------

    1. .slogin file					user's HOME dir

    2. session history file				user's HOME dir
    3. alias file                                 	user's HOME dir

    4. color table files				SDIR directories
    5. fov description files				SDIR directories


    6. image workfiles (eg. "fi" command)		current dir
    7. take files					current dir
    8. slice files					current dir
    9. scatterplot files				current dir
    10. flatten files (output from flatten command)	current dir
    11. replicate files					current dir
    12. crop files					current dir

In most cases, the default can be overridden by specifying a full 
path name (beginning with a slash) in the appropriate command, eg. 
fi /q/booth/image/p10

The cd command changes the default for file types 6 through 12 to a new
directory. The cd command does not normally change the directory
used for file types 1 through 5.  

To change the directories used for file types 2 and 3, you must create
a .slogin file:

Upon invocation, the s program tries to "take" the file .slogin in the user's
HOME directory (i.e.  the directory given by the HOME environment variable).  
If you want skyview to look elsewhere, create an environment variable SLOGIN 
giving the full path name.  For example:

setenv SLOGIN /usr/booth/batfiles/.slogin

If you do not want the file types 2 and 3 to be in your home 
directory, then you must place a cd command as the first 
line in your .slogin file.  The directory you give in 
this command must be a full path specification beginning with
a slash (/) or a tilde (~).  No alias substitution will be done on this command.
When appearing in this special place, a cd command means to override
the default directory for file types 2 and 3.  Subsequent cd
commands will have their normal meaning (change default for 
image files etc.).  *

As an example, my home directory is /usr/booth.  I want my alias
file and my session history file to be in
/usr/booth/skyflux.  I want my image files to be in /usr/booth/images.
I provide for this automatically by creating a file named .slogin in
my home directory /usr/booth.  It contains 2 lines:

cd /usr/booth/skyflux
cd /usr/booth/images

The first line (by virtue of its special position) 
sets the default for file types 2-4.  The second
line is not in that special place, so it is an ordinary cd 
command and changes the default directory for image files etc.





* The reasons for the restrictions are as follows:  the special
cd command must be the first one encountered by the program
because it sets the location of the alias file which is used
by all subsequent commands.  If it were not first, there would
be no way to do alias substitution on the first command.  The
full path must be specified to avoid confusion if the user
is not in his home directory when he invokes the skyview program.
