/*
Copyright (C) 1992, California Institute of Technology.
U.S. Government Sponsorship under NASA Contract NAS7-918 is acknowledged.
*/

/* this is the driver for the stand-alone screen_dump program sd */
#include <stdio.h>
#include "jconfig.h"
#include "jgio.h"
/*   #include <sys/jg.h>  */
#include "skyview.h"
#include "img_jup.h"
#include "img.h"
#include "parse.h"
#include <sys/types.h>
#include <netinet/in.h>

JFILE *J12file, *j12prep();
int tappos, filnbr;
int mfd = -1;
int tmpfd = -1;
int debug = 0;
FILE *session;
char Bundle_name[] = "s";

/* dummy declarations for linking with other modules */
int do_alias;
char pathnam[1], plane, *fi_name;
int control_c;
struct img *curr_img;
int captive = FALSE;
char save_line[MAXLINE];
int server = FALSE;

int bitpix;         /* bits per pixel on tape and in workfile */
int blank;          /* value of missing pixel */
int pixels, lines;  /* pixels per line, lines in image */
int naxis;
int naxis3;
int ss, sl, es, el;  /* starting and ending line and sample */
double cdelt1, cdelt2, twist;  /* pixel dimensions, deepsky twist angle */
double bscale, b_zero, glat, glong, crval3;
char bunit[80];   /* units of pixel flux value */
char ctype1[80], ctype2[80];  /* strings "lat", "lon", etc. */
char ctype1sav[80], ctype2sav[80];  /* strings saved for tapewrite */
char object[80];        /* name of object */
int maptype;    /* projection type */
int take_param;
double slice_scale;	   /* last scale used in slice */
double slow, shigh;   /* range values used in last paint command */
char slice_x[80], slice_y[80], slice_x2[80], slice_y2[80];
char org_path[50];      /* path for session, alias, and color tables */
char filnam[MAXPATHLEN];      /* current image workfile name (with path already
		      /* prepended */
struct hdrstruct filehdr;
int crpix1int, crpix2int;
int area_number, x_area[100][MAX_AREAS];
int vax_bytes;

main(argc, argv)
int argc;
char *argv[];
{
    u_long netlong;

    /* test for byteorder */
    netlong = 0x12345678;
    netlong = htonl(netlong);
    if (netlong == 0x12345678)
	vax_bytes = FALSE;
    else if (netlong == 0x78563412)
	vax_bytes = TRUE;
    else
    {
	printf("sd error:  unknown byte order on this machine\n");
	exit(1);
    }

    J12file = j12prep("/dev/ju0g");
    /*
    J12file = jginit(0, 0, CLT8, 1, 0, 4);
    */
    if (J12file == NULL)
    {
	perror("graphics initialization error");
	exit(0);
    }
    session = fopen("/dev/null", "w");

    screen_dump(argc, argv);
}

/* dummy declarations for linking to parse.c */
expand_alias()
{
}
image_setup()
{
}
set_file_sys()
{
}
wait_for_event()
{
}
print_header_line()
{
}
enable_control_c()
{
}
fill_glob()
{
}
imopen()
{
}
iahdr()
{
}
round()
{
}
find_range()
{
}
get_hist()
{
}
do_sync()
{
}
